/* crypto.c */
#ifdef HAVE_OPENSSL
crypto_ctx *openssl_crypto_init(struct options opt, int dir);
struct Packet openssl_do_encrypt(crypto_ctx *ctx, unsigned char *intext, int size, unsigned char *key, unsigned char *iv);
struct Packet openssl_do_decrypt(crypto_ctx *ctx, unsigned char *intext, int size, unsigned char *key, unsigned char *iv);
void openssl_crypto_deinit(crypto_ctx *ctx);
#else
crypto_ctx gcrypt_crypto_init(struct options opt, int dir);
struct Packet gcrypt_do_encrypt(crypto_ctx ctx, unsigned char *intext, int size, unsigned char *key, unsigned char *iv);
struct Packet gcrypt_do_decrypt(crypto_ctx ctx, unsigned char *intext, int size, unsigned char *key, unsigned char *iv);
void gcrypt_crypto_deinit(crypto_ctx ctx);
#endif
