/*
 * Ctunnel - Cyptographic tunnel.
 * Copyright (C) 2008-2011 Jess Mahan <ctunnel@nardcore.org>
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <time.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>

#include "config.h"
#include "ctunnel.h"

struct Compress z_compress_init(struct options opt)
{
    struct Compress comp;
    int ret = 0;

    comp.zip.zalloc = Z_NULL;
    comp.zip.zfree = Z_NULL;
    comp.zip.opaque = Z_NULL;
    ret = deflateInit(&comp.zip, opt.comp_level);
    if (ret != Z_OK) {
	ctunnel_log(stderr, LOG_CRIT, "Error Initializing Zlib (deflate)");
	exit(1);
    }

    comp.unzip.zalloc = Z_NULL;
    comp.unzip.zfree = Z_NULL;
    comp.unzip.opaque = Z_NULL;
    comp.unzip.avail_in = 0;
    comp.unzip.next_in = Z_NULL;
    ret = inflateInit(&comp.unzip);
    if (ret != Z_OK) {
	ctunnel_log(stderr, LOG_CRIT, "Error Initializing Zlib (inflate)");
	exit(1);
    }

    return comp;
}
struct Packet z_compress(z_stream str, unsigned char *data, int size)
{
    int ret = 0;
    struct Packet comp;

    comp.data = calloc(1, sizeof(char *) * 20048);


    str.avail_in = size;
    str.next_in = data;
    do {
        str.avail_out = 20048;
        str.next_out = comp.data;
        ret = deflate(&str, Z_PARTIAL_FLUSH);
        comp.len = 20048 - str.avail_out;
    } while (str.avail_out == 0);

    return comp;
}

struct Packet z_uncompress(z_stream str, unsigned char *data, int size)
{
    int ret = 0;
    struct Packet comp;

    comp.data = calloc(1, sizeof(char *) * 20048);

    str.avail_in = size;
    str.next_in = data;
    str.avail_out = 20048;
    str.next_out = comp.data;

    ret = inflate(&str, Z_FINISH);
    comp.len = 20048 - str.avail_out;

    return comp;
}
